package webwisdom.tango.messages;

import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.consts.*;
import java.io.*;
 

public class CAppRequestEventMessage extends AppEventMessage
{
  public CAppRequestEventMessage(byte[] tab)
  {
    super(Const.CONTROL, tab);
  }

  //For inter-application communication use
  public static byte[] prepareData(String appname, byte[] tab)
  {
    int alength = appname.length();
    ByteArrayOutputStream outtab = new ByteArrayOutputStream();
    outtab.write(CAConsts.DATAPASS);

    outtab.write((byte) alength);
    int i=0; 
    byte[] onebyte = new byte[1];
    while (i<alength) 
    {
      appname.getBytes(i,i+1,onebyte,0);
      outtab.write(onebyte[0]); 
      i++;
    }

    ByteArrayInputStream data = new ByteArrayInputStream(tab);
    i=0;
    int available = data.available();
    while (i<available) 
    {
      byte b = (byte) data.read();
      outtab.write(b); 
      i++; 
    }

    return outtab.toByteArray();    
  }

  public static byte[] extractData(byte[] src,int srclen)
  {
    ByteArrayOutputStream datapass = new ByteArrayOutputStream();
    int appname_len = src[1];
    datapass.write(src,appname_len+2,srclen-appname_len-2);

    return datapass.toByteArray();
  }

  public static String extractSender(byte[] src,int srclen)
  {
    ByteArrayOutputStream appname = new ByteArrayOutputStream();
    int appname_len = src[1];
    appname.write(src,2,appname_len);
    
    return new String(appname.toByteArray(),0);
  }

}































